;
;    TestFTP
;    ⮢   祪  .
;
;    : Hex
;    : www.mestack.narod.ru
;
;     Fasm'  Menuet.
;
use32

                org     0x0
  db     'MENUET01'  ; 8- 䨪 MenuetOS
  dd     0x01        ;   (ᥣ 1)
  dd     START       ;  ࢮ 
  dd     I_END       ; ࠧ ணࠬ
  dd     0x100000    ; ⢮ 
  dd     0x100000    ;  設 
  dd     0x0         ;    ࠬ஢ ( ᯮ)
  dd     0x0         ; १ࢨ஢

include 'macros.inc'

START:                          ; start of execution

    mov  dword [prompt], p1
    mov  dword [promptlen], p1len - p1
    call draw_window            ; at first, draw the window

still:
    
    mov  eax,23                 ; wait here for event
    mov  ebx,1
    int  0x40

    cmp  eax,1                  ; redraw request ?
    jz   red
    cmp  eax,2                  ; key in buffer ?
    jz   key
    cmp  eax,3                  ; button in buffer ?
    jz   button

    ; any data from the socket?
    mov  eax, 53
    mov  ebx, 2                  ; Get # of bytes in input queue
    mov  ecx, [socketNum]
    int  0x40

    cmp  eax, 0
    jne  read_input

    jmp  still

red:                           ; redraw
    call draw_window
    jmp  still

key:                            ; Keys are not valid at this part of the
    mov  eax,2                  ; loop. Just read it and ignore
    int  0x40
    jmp  still

button:                         ; button
    mov  eax,17                 ; get id
    int  0x40

    cmp  ah,1                   ; button id=1 ?
    jnz  noclose
  
    mov     eax,53          ; Stack Interface
    mov     ebx,8           ; Close TCP socket
    mov     ecx,[DataSocket]
    int     0x40
    
    mov     eax,53          ; Stack Interface
    mov     ebx,8           ; Close TCP socket
    mov     ecx,[socketNum]
    int     0x40

    mov  eax,-1             ; close this program
    int  0x40

noclose:
    cmp  ah,4                   ; copy file to local machine?

    ; Open sockets and connect to FTP-server
    je connect  

    jmp  still

stopload:

    cmp  ah,5

    je disconnect

    jmp  still

read_input:

    mov  esi,cmdsoc
    xor  esi,esi

    mov  eax,53
    mov  ebx,3            ; Get a byte from socket in bl
    mov  ecx,[socketNum]
    int  0x40

    call  ftpcomtransm     ; process incoming ftp command

    ; Keep processing data until there is no more to process
    mov  eax,53
    mov  ebx,2            ; Get # of bytes in input queue
    mov  ecx,[socketNum]
    int  0x40

    cmp  eax,0
    jne  read_input
    jmp  still
;***************************************************************************
;   Function
;      disconnect
;
;   Description
;       Closes all sockets
;
;   Inputs
;       None
;
;***************************************************************************
disconnect:

    mov     eax,53          ; Stack Interface
    mov     ebx,8           ; Close TCP socket
    mov     ecx,[DataSocket]
    int     0x40
    
    mov     eax,53          ; Stack Interface
    mov     ebx,8           ; Close TCP socket
    mov     ecx,[socketNum]
    int     0x40
    
    mov  dword [prompt], p7
    mov  dword [promptlen], p7len - p7
    call draw_window

    jmp     still
;***************************************************************************
;   Function
;      connect
;
;   Description
;       Open the sockets
;
;   Inputs
;       None
;
;***************************************************************************
connect:
    mov  dword [prompt], p5
    mov  dword [promptlen], p5len - p5
    call draw_window

    mov     eax,53          ; Stack Interface
    mov     ebx,5           ; Open TCP socket
    mov     esi,dword [DataIP]  ; remote IP address
    mov     edx,21             ; remote port
    mov     ecx,[socketNum]        ; ftp command port id
    mov     edi,1              ; active open
    int     0x40
    mov     [socketNum],eax

    mov     eax, 53     ; Stack Interface
    mov     ebx, 5      ; Open TCP socket
    mov     esi, 0      ; No remote IP address
    mov     edx, 0      ; No remote port
    mov     ecx, [DataSocket]  ; ftp data port id
    mov     edi, 0      ; passive open
    int     0x40
    mov     [DataSocket], eax
   
    mov     eax,5
    mov     ebx,5               ; Delay for up 500ms
    int     0x40

    call    sendcom

    jmp     still
;***************************************************************************
;   Function
;      sendcom
;
;   Description
;       Send commands to server socket.
;       
;
;   Inputs
;       None 
;
;   Outputs
;       commands
;
;***************************************************************************
sendcom:

    mov  dword [prompt], p6
    mov  dword [promptlen], p6len - p6
    call draw_window

 ; send an 'loginStr0'
 mov  eax,53
 mov  ebx,7
 mov  ecx,[socketNum]
 mov  edx,loginStr0_end - loginStr0
 mov  esi,loginStr0
 int  0x40
 
    mov     eax,5
    mov     ebx,5               ; Delay for up 500ms
    int     0x40
 
 ; send an 'loginStr1'
 mov  eax,53
 mov  ebx,7
 mov  ecx,[socketNum]
 mov  edx,loginStr1_end - loginStr1
 mov  esi,loginStr1
 int  0x40

    mov     eax,5
    mov     ebx,5               ; Delay for up 500ms
    int     0x40
 
 ; send an 'loginStr2'
 mov  eax, 53
 mov  ebx, 7
 mov  ecx, [socketNum]
 mov  edx, loginStr2_end - loginStr2
 mov  esi, loginStr2
 int  0x40

    mov     eax,5
    mov     ebx,5               ; Delay for up 500ms
    int     0x40
 
 ; send an 'portStr'
 mov  eax, 53
 mov  ebx, 7
 mov  ecx, [socketNum]
 mov  edx, portStr_end - portStr
 mov  esi, portStr
 int  0x40

   mov     eax,5
   mov     ebx,5               ; Delay for up 500ms
   int     0x40
 
 ; send an 'fileStr'
 mov  eax, 53
 mov  ebx, 7
 mov  ecx, [socketNum]
 mov  edx, fileStr_end - fileStr
 mov  esi, fileStr
 int  0x40
 
  mov  dword [prompt], p8
  mov  dword [promptlen], p8len - p8
  call draw_window

  call getFile

  jmp     still

;***************************************************************************
;   Function
;      getFile
;
;   Description
;       Receives the specified file over the open data socket
;       The file to receive is named in the buff string
;
;   Inputs
;       None 
;
;   Outputs
;       None
;
;***************************************************************************
getFile:
  mov  dword [prompt], p2
  mov  dword [promptlen], p2len - p2
  call draw_window 
  mov  [fsize], eax            ; Start filelength at 0
  jmp  cs001
    ; Read data from the socket until the socket closes
    ; loop
    ;   loop
    ;     read byte from socket
    ;     write byte to file buffer
    ;   until no more bytes in socket
    ;   sleep 100ms
    ; until socket no longer connected
    ; write file to ram
;-----------------------------------
cs001:
    ; wait a bit
    mov  eax,5
    mov  ebx,1                 ; Delay for up 100ms
    int  0x40

    mov  eax,53
    mov  ebx,6                 ; Get socket status
    mov  ecx,[DataSocket]
    int  0x40

    cmp  eax, 4
    je   gf000
    jne  cs001
;-----------------------------------
gf000:
   
    mov  esi,dtr
   
  get_data:
   
    mov  eax,53
    mov  ebx,3
    mov  ecx,[DataSocket]
    int  0x40

    mov  [esi], bl
    inc  esi
    inc  dword [fsize]

    mov  eax,53
    mov  ebx,2
    mov  ecx,[DataSocket]
    int  0x40
   
    cmp  eax,0
    je   gf_sleep
    jne  get_data
;-----------------------------------

gf_sleep:
    ; Check to see if socket closed...
    mov     eax,53
    mov     ebx,6               ; Get socket status
    mov     ecx,[DataSocket]
    int     0x40

    cmp     eax, 7
    jne     gf001               ; still open, so just sleep a bit

    ; Finished, so write the file
    mov  eax,33
    mov  ebx,source
    mov  ecx,dtr
    mov  edx,[fsize]
    mov  esi,0
    int  0x40

    mov  dword [prompt], p4
    mov  dword [promptlen], p4len - p4
    call draw_window
 
 ; send an 'QUIT'
 mov  eax, 53
 mov  ebx, 7
 mov  ecx, [socketNum]
 mov  edx, quit_end - quit
 mov  esi, quit
 int  0x40
 
 ret                         ; Finished

gf001:
    ; wait a bit
    mov     eax,5
    mov     ebx,1               ; Delay for up 100ms
    int     0x40
    jmp     get_data            ; try for more data
  
  jmp     still
;***************************************************************************
;   Function
;      ftpcomtransm
;
;   Description
;       Prcoesses incoming command data, calling a handler for each command.
;       Commands are built up in buff before being processed.
;
;   Inputs
;       Character to add in bl
;
;***************************************************************************
ftpcomtransm:
    mov  [esi], bl
    inc  esi

    ; Do we have an end of line? (LF)
    ; if not, just exit
    cmp     bl, 0x0a
    jne     fct_exit
   
    mov  dword [prompt], cmdsoc
    mov  dword [promptlen], 20
    call draw_window

fct_exit:
ret


;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40

                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,100*65536+230         ; [x start] *65536 + [x size]
    mov  ecx,100*65536+170         ; [y start] *65536 + [y size]
    mov  edx,0x03224466            ; color of work area RRGGBB
    mov  esi,0x00334455            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x00ddeeff            ; color of frames    RRGGBB
    int  0x40

                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x00ffffff            ; color of text RRGGBB
    mov  edx,labelt                ; pointer to text beginning
    mov  esi,labellen-labelt       ; text length
    int  0x40


    mov  eax,8                     ; START BUTTON
    mov  ebx,20*65536+190
    mov  ecx,79*65536+15
    mov  edx,4
    mov  esi,0x557799
    int  0x40
    
    mov  eax,8                     ; STOP BUTTON
    mov  ebx,20*65536+190
    mov  ecx,111*65536+15
    mov  edx,5
    mov  esi,0x557499
    int  0x40
      
    ; copy the prompt to the screen buffer
    mov  esi,[prompt]
    mov  edi,text+280
    mov  ecx,[promptlen]
    rep  movsb

    ; Re-draw the screen text
    cld
    mov  ebx,25*65536+35           ; draw info text with function 4
    mov  ecx,0xffffff
    mov  edx,text
    mov  esi,40

  newline:
    mov  eax,4
    int  0x40
    add  ebx,16
    add  edx,40
    cmp  [edx],byte 'x'
    jnz  newline


    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40

    ret


; DATA AREA

;fileposition dd 0 ; Points to the current point in the file
;filesize  dd 0 ; The number of bytes written / left to write
;fileblocksize dw 0 ; The number of bytes to send in this frame

text:
    db '                                        '
    db '                                        '
    db '                                        '
    db '      㧨 䠩                    '
    db '                                        '
    db '    ⠭ 㧪                 '
    db '                                        '
    db '                                        '
    db 'x <- END MARKER, DONT DELETE            '


labelt:
    db   'TestFTP'
labellen:

DataIP db 192,168,0,2
DataPort dd 21
prompt dd 0
promptlen dd 0
source db 'THEX.ASM'

buff:     times 256 db 0  ; Could put this after iend

p1  db ' '
p1len:

p2  db '饬 䠩...'
p2len:

p3  db ' .࠭塞 ...'
p3len:

p4  db ' ᯥ譮 砭.'
p4len:

p5  db '뢠 ...'
p5len:

p6  db '.뫠 ...'
p6len:

p7  db '㧪 ࢠ.'
p7len:

p8  db '뫪  襭.'
p8len:

;稥   ࢥ

loginStr0:     db  'USER Hex',0x0d,0x0a
loginStr0_end:

loginStr1:     db  'PASS 123',0x0d,0x0a
loginStr1_end:

loginStr2:     db  'TYPE A',0x0d,0x0a
loginStr2_end:

portStr:       db  'PORT 192,168,0,1,7,208',0x0d,0x0a
portStr_end:

fileStr:       db  'RETR THEX.ASM',0x0d,0x0a
fileStr_end:

quit:          db  'QUIT',0x0d,0x0a
quit_end:

socketNum dd 21
fsize:    dd      0
DataSocket dd 2000
cmdsoc: dd 0
dtr: dd 0

I_END:






