;
;   GIF Include and Play animation Mini Sample by Pavlushin Evgeni for ASCL
;   Load bmp image from hd and show with macros
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     0x0 , 0x0               ; I_Param , I_Icon

;******************************************************************************


include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
;step1 define offset of hash area for unpacking gif file
;      size 16384+4 bytes
    gif_hash_offset = gif_hash_area
;step2 converting gif format to animation format for easy out to screen
;      gif_file_area - offset of gif load file
;      img_area      - offset of images list
;      num_of_frames - dword num of animation frames
    giftoani gif_file_area,img_area,[num_of_frames]
;step3 draw window
    call draw_window

;Main loop wait for event with 10msec (Animation speed)
still:
    timeevent 10,no_event,red,key,button
  no_event:
; calucalting frame offset
    getframeoff [num_of_frame],img_area,esi
; out frame to screen
    setframe 5,22,esi
; next frame
    inc  [num_of_frame]
    mov  eax,dword [num_of_frames]
    cmp  [num_of_frame],eax
    jnae still
; animation loop
    mov  [num_of_frame],dword 0
    jmp  still

  red:
    call draw_window
    jmp still

  key:                          ; key
    int  0x40                   ; read (eax=2)
    jmp  still                  ; not testing

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window   40,40,(220+9),(134+26),window_Skinned+0x00ffffff
    label    8,8,'ASCL Incl&Play GIF Animation',cl_White+font_Big
    endwd
    ret

; DATA AREA
num_of_frames dd 0
num_of_frame  dd 0
IM_END:
;gif_file_area ~21500
gif_file_area:
file 'explode1.gif'   ;include gif animation file
rb 50                 ;temp 50 bytes
img_area:             ;area for animation
rb (209*134*3+8)*16   ;16 frames
gif_hash_area:
rd 4096+1      ;hash area size for unpacking GIF
I_END:
